// This file was generated by counterfeiter
package apifakes

import (
	"sync"

	"code.cloudfoundry.org/cli/cf/api"
	"code.cloudfoundry.org/cli/cf/models"
)

type FakeServiceKeyRepository struct {
	CreateServiceKeyStub        func(serviceKeyGUID string, keyName string, params map[string]interface{}) error
	createServiceKeyMutex       sync.RWMutex
	createServiceKeyArgsForCall []struct {
		serviceKeyGUID string
		keyName        string
		params         map[string]interface{}
	}
	createServiceKeyReturns struct {
		result1 error
	}
	ListServiceKeysStub        func(serviceKeyGUID string) ([]models.ServiceKey, error)
	listServiceKeysMutex       sync.RWMutex
	listServiceKeysArgsForCall []struct {
		serviceKeyGUID string
	}
	listServiceKeysReturns struct {
		result1 []models.ServiceKey
		result2 error
	}
	GetServiceKeyStub        func(serviceKeyGUID string, keyName string) (models.ServiceKey, error)
	getServiceKeyMutex       sync.RWMutex
	getServiceKeyArgsForCall []struct {
		serviceKeyGUID string
		keyName        string
	}
	getServiceKeyReturns struct {
		result1 models.ServiceKey
		result2 error
	}
	DeleteServiceKeyStub        func(serviceKeyGUID string) error
	deleteServiceKeyMutex       sync.RWMutex
	deleteServiceKeyArgsForCall []struct {
		serviceKeyGUID string
	}
	deleteServiceKeyReturns struct {
		result1 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeServiceKeyRepository) CreateServiceKey(serviceKeyGUID string, keyName string, params map[string]interface{}) error {
	fake.createServiceKeyMutex.Lock()
	fake.createServiceKeyArgsForCall = append(fake.createServiceKeyArgsForCall, struct {
		serviceKeyGUID string
		keyName        string
		params         map[string]interface{}
	}{serviceKeyGUID, keyName, params})
	fake.recordInvocation("CreateServiceKey", []interface{}{serviceKeyGUID, keyName, params})
	fake.createServiceKeyMutex.Unlock()
	if fake.CreateServiceKeyStub != nil {
		return fake.CreateServiceKeyStub(serviceKeyGUID, keyName, params)
	} else {
		return fake.createServiceKeyReturns.result1
	}
}

func (fake *FakeServiceKeyRepository) CreateServiceKeyCallCount() int {
	fake.createServiceKeyMutex.RLock()
	defer fake.createServiceKeyMutex.RUnlock()
	return len(fake.createServiceKeyArgsForCall)
}

func (fake *FakeServiceKeyRepository) CreateServiceKeyArgsForCall(i int) (string, string, map[string]interface{}) {
	fake.createServiceKeyMutex.RLock()
	defer fake.createServiceKeyMutex.RUnlock()
	return fake.createServiceKeyArgsForCall[i].serviceKeyGUID, fake.createServiceKeyArgsForCall[i].keyName, fake.createServiceKeyArgsForCall[i].params
}

func (fake *FakeServiceKeyRepository) CreateServiceKeyReturns(result1 error) {
	fake.CreateServiceKeyStub = nil
	fake.createServiceKeyReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeServiceKeyRepository) ListServiceKeys(serviceKeyGUID string) ([]models.ServiceKey, error) {
	fake.listServiceKeysMutex.Lock()
	fake.listServiceKeysArgsForCall = append(fake.listServiceKeysArgsForCall, struct {
		serviceKeyGUID string
	}{serviceKeyGUID})
	fake.recordInvocation("ListServiceKeys", []interface{}{serviceKeyGUID})
	fake.listServiceKeysMutex.Unlock()
	if fake.ListServiceKeysStub != nil {
		return fake.ListServiceKeysStub(serviceKeyGUID)
	} else {
		return fake.listServiceKeysReturns.result1, fake.listServiceKeysReturns.result2
	}
}

func (fake *FakeServiceKeyRepository) ListServiceKeysCallCount() int {
	fake.listServiceKeysMutex.RLock()
	defer fake.listServiceKeysMutex.RUnlock()
	return len(fake.listServiceKeysArgsForCall)
}

func (fake *FakeServiceKeyRepository) ListServiceKeysArgsForCall(i int) string {
	fake.listServiceKeysMutex.RLock()
	defer fake.listServiceKeysMutex.RUnlock()
	return fake.listServiceKeysArgsForCall[i].serviceKeyGUID
}

func (fake *FakeServiceKeyRepository) ListServiceKeysReturns(result1 []models.ServiceKey, result2 error) {
	fake.ListServiceKeysStub = nil
	fake.listServiceKeysReturns = struct {
		result1 []models.ServiceKey
		result2 error
	}{result1, result2}
}

func (fake *FakeServiceKeyRepository) GetServiceKey(serviceKeyGUID string, keyName string) (models.ServiceKey, error) {
	fake.getServiceKeyMutex.Lock()
	fake.getServiceKeyArgsForCall = append(fake.getServiceKeyArgsForCall, struct {
		serviceKeyGUID string
		keyName        string
	}{serviceKeyGUID, keyName})
	fake.recordInvocation("GetServiceKey", []interface{}{serviceKeyGUID, keyName})
	fake.getServiceKeyMutex.Unlock()
	if fake.GetServiceKeyStub != nil {
		return fake.GetServiceKeyStub(serviceKeyGUID, keyName)
	} else {
		return fake.getServiceKeyReturns.result1, fake.getServiceKeyReturns.result2
	}
}

func (fake *FakeServiceKeyRepository) GetServiceKeyCallCount() int {
	fake.getServiceKeyMutex.RLock()
	defer fake.getServiceKeyMutex.RUnlock()
	return len(fake.getServiceKeyArgsForCall)
}

func (fake *FakeServiceKeyRepository) GetServiceKeyArgsForCall(i int) (string, string) {
	fake.getServiceKeyMutex.RLock()
	defer fake.getServiceKeyMutex.RUnlock()
	return fake.getServiceKeyArgsForCall[i].serviceKeyGUID, fake.getServiceKeyArgsForCall[i].keyName
}

func (fake *FakeServiceKeyRepository) GetServiceKeyReturns(result1 models.ServiceKey, result2 error) {
	fake.GetServiceKeyStub = nil
	fake.getServiceKeyReturns = struct {
		result1 models.ServiceKey
		result2 error
	}{result1, result2}
}

func (fake *FakeServiceKeyRepository) DeleteServiceKey(serviceKeyGUID string) error {
	fake.deleteServiceKeyMutex.Lock()
	fake.deleteServiceKeyArgsForCall = append(fake.deleteServiceKeyArgsForCall, struct {
		serviceKeyGUID string
	}{serviceKeyGUID})
	fake.recordInvocation("DeleteServiceKey", []interface{}{serviceKeyGUID})
	fake.deleteServiceKeyMutex.Unlock()
	if fake.DeleteServiceKeyStub != nil {
		return fake.DeleteServiceKeyStub(serviceKeyGUID)
	} else {
		return fake.deleteServiceKeyReturns.result1
	}
}

func (fake *FakeServiceKeyRepository) DeleteServiceKeyCallCount() int {
	fake.deleteServiceKeyMutex.RLock()
	defer fake.deleteServiceKeyMutex.RUnlock()
	return len(fake.deleteServiceKeyArgsForCall)
}

func (fake *FakeServiceKeyRepository) DeleteServiceKeyArgsForCall(i int) string {
	fake.deleteServiceKeyMutex.RLock()
	defer fake.deleteServiceKeyMutex.RUnlock()
	return fake.deleteServiceKeyArgsForCall[i].serviceKeyGUID
}

func (fake *FakeServiceKeyRepository) DeleteServiceKeyReturns(result1 error) {
	fake.DeleteServiceKeyStub = nil
	fake.deleteServiceKeyReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeServiceKeyRepository) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.createServiceKeyMutex.RLock()
	defer fake.createServiceKeyMutex.RUnlock()
	fake.listServiceKeysMutex.RLock()
	defer fake.listServiceKeysMutex.RUnlock()
	fake.getServiceKeyMutex.RLock()
	defer fake.getServiceKeyMutex.RUnlock()
	fake.deleteServiceKeyMutex.RLock()
	defer fake.deleteServiceKeyMutex.RUnlock()
	return fake.invocations
}

func (fake *FakeServiceKeyRepository) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ api.ServiceKeyRepository = new(FakeServiceKeyRepository)
