// Code generated by counterfeiter. DO NOT EDIT.
package apifakes

import (
	"sync"

	"code.cloudfoundry.org/cli/cf/api"
	"code.cloudfoundry.org/cli/cf/models"
)

type FakeUserProvidedServiceInstanceRepository struct {
	CreateStub        func(name, drainURL string, routeServiceURL string, params map[string]interface{}, tags []string) (apiErr error)
	createMutex       sync.RWMutex
	createArgsForCall []struct {
		name            string
		drainURL        string
		routeServiceURL string
		params          map[string]interface{}
		tags            []string
	}
	createReturns struct {
		result1 error
	}
	createReturnsOnCall map[int]struct {
		result1 error
	}
	UpdateStub        func(serviceInstanceFields models.ServiceInstanceFields) (apiErr error)
	updateMutex       sync.RWMutex
	updateArgsForCall []struct {
		serviceInstanceFields models.ServiceInstanceFields
	}
	updateReturns struct {
		result1 error
	}
	updateReturnsOnCall map[int]struct {
		result1 error
	}
	GetSummariesStub        func() (models.UserProvidedServiceSummary, error)
	getSummariesMutex       sync.RWMutex
	getSummariesArgsForCall []struct{}
	getSummariesReturns     struct {
		result1 models.UserProvidedServiceSummary
		result2 error
	}
	getSummariesReturnsOnCall map[int]struct {
		result1 models.UserProvidedServiceSummary
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeUserProvidedServiceInstanceRepository) Create(name string, drainURL string, routeServiceURL string, params map[string]interface{}, tags []string) (apiErr error) {
	var tagsCopy []string
	if tags != nil {
		tagsCopy = make([]string, len(tags))
		copy(tagsCopy, tags)
	}
	fake.createMutex.Lock()
	ret, specificReturn := fake.createReturnsOnCall[len(fake.createArgsForCall)]
	fake.createArgsForCall = append(fake.createArgsForCall, struct {
		name            string
		drainURL        string
		routeServiceURL string
		params          map[string]interface{}
		tags            []string
	}{name, drainURL, routeServiceURL, params, tagsCopy})
	fake.recordInvocation("Create", []interface{}{name, drainURL, routeServiceURL, params, tagsCopy})
	fake.createMutex.Unlock()
	if fake.CreateStub != nil {
		return fake.CreateStub(name, drainURL, routeServiceURL, params, tags)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.createReturns.result1
}

func (fake *FakeUserProvidedServiceInstanceRepository) CreateCallCount() int {
	fake.createMutex.RLock()
	defer fake.createMutex.RUnlock()
	return len(fake.createArgsForCall)
}

func (fake *FakeUserProvidedServiceInstanceRepository) CreateArgsForCall(i int) (string, string, string, map[string]interface{}, []string) {
	fake.createMutex.RLock()
	defer fake.createMutex.RUnlock()
	return fake.createArgsForCall[i].name, fake.createArgsForCall[i].drainURL, fake.createArgsForCall[i].routeServiceURL, fake.createArgsForCall[i].params, fake.createArgsForCall[i].tags
}

func (fake *FakeUserProvidedServiceInstanceRepository) CreateReturns(result1 error) {
	fake.CreateStub = nil
	fake.createReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeUserProvidedServiceInstanceRepository) CreateReturnsOnCall(i int, result1 error) {
	fake.CreateStub = nil
	if fake.createReturnsOnCall == nil {
		fake.createReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.createReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeUserProvidedServiceInstanceRepository) Update(serviceInstanceFields models.ServiceInstanceFields) (apiErr error) {
	fake.updateMutex.Lock()
	ret, specificReturn := fake.updateReturnsOnCall[len(fake.updateArgsForCall)]
	fake.updateArgsForCall = append(fake.updateArgsForCall, struct {
		serviceInstanceFields models.ServiceInstanceFields
	}{serviceInstanceFields})
	fake.recordInvocation("Update", []interface{}{serviceInstanceFields})
	fake.updateMutex.Unlock()
	if fake.UpdateStub != nil {
		return fake.UpdateStub(serviceInstanceFields)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.updateReturns.result1
}

func (fake *FakeUserProvidedServiceInstanceRepository) UpdateCallCount() int {
	fake.updateMutex.RLock()
	defer fake.updateMutex.RUnlock()
	return len(fake.updateArgsForCall)
}

func (fake *FakeUserProvidedServiceInstanceRepository) UpdateArgsForCall(i int) models.ServiceInstanceFields {
	fake.updateMutex.RLock()
	defer fake.updateMutex.RUnlock()
	return fake.updateArgsForCall[i].serviceInstanceFields
}

func (fake *FakeUserProvidedServiceInstanceRepository) UpdateReturns(result1 error) {
	fake.UpdateStub = nil
	fake.updateReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeUserProvidedServiceInstanceRepository) UpdateReturnsOnCall(i int, result1 error) {
	fake.UpdateStub = nil
	if fake.updateReturnsOnCall == nil {
		fake.updateReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.updateReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeUserProvidedServiceInstanceRepository) GetSummaries() (models.UserProvidedServiceSummary, error) {
	fake.getSummariesMutex.Lock()
	ret, specificReturn := fake.getSummariesReturnsOnCall[len(fake.getSummariesArgsForCall)]
	fake.getSummariesArgsForCall = append(fake.getSummariesArgsForCall, struct{}{})
	fake.recordInvocation("GetSummaries", []interface{}{})
	fake.getSummariesMutex.Unlock()
	if fake.GetSummariesStub != nil {
		return fake.GetSummariesStub()
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.getSummariesReturns.result1, fake.getSummariesReturns.result2
}

func (fake *FakeUserProvidedServiceInstanceRepository) GetSummariesCallCount() int {
	fake.getSummariesMutex.RLock()
	defer fake.getSummariesMutex.RUnlock()
	return len(fake.getSummariesArgsForCall)
}

func (fake *FakeUserProvidedServiceInstanceRepository) GetSummariesReturns(result1 models.UserProvidedServiceSummary, result2 error) {
	fake.GetSummariesStub = nil
	fake.getSummariesReturns = struct {
		result1 models.UserProvidedServiceSummary
		result2 error
	}{result1, result2}
}

func (fake *FakeUserProvidedServiceInstanceRepository) GetSummariesReturnsOnCall(i int, result1 models.UserProvidedServiceSummary, result2 error) {
	fake.GetSummariesStub = nil
	if fake.getSummariesReturnsOnCall == nil {
		fake.getSummariesReturnsOnCall = make(map[int]struct {
			result1 models.UserProvidedServiceSummary
			result2 error
		})
	}
	fake.getSummariesReturnsOnCall[i] = struct {
		result1 models.UserProvidedServiceSummary
		result2 error
	}{result1, result2}
}

func (fake *FakeUserProvidedServiceInstanceRepository) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.createMutex.RLock()
	defer fake.createMutex.RUnlock()
	fake.updateMutex.RLock()
	defer fake.updateMutex.RUnlock()
	fake.getSummariesMutex.RLock()
	defer fake.getSummariesMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeUserProvidedServiceInstanceRepository) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ api.UserProvidedServiceInstanceRepository = new(FakeUserProvidedServiceInstanceRepository)
